/** @file
 * VirtualBox API Enum Stringifier - Header.
 *
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl
 * Generator: src/VBox/Main/idl/stringify-enums.xsl
 */

/*
 * Copyright (C) 2022-2025 Oracle and/or its affiliates.
 *
 * This file is part of VirtualBox base platform packages, as
 * available from https://www.virtualbox.org.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation, in version 3 of the
 * License.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <https://www.gnu.org/licenses>.
 *
 * SPDX-License-Identifier: GPL-3.0-only
 */


#ifndef INCLUDED_GENERATED_StringifyEnums_h
#define INCLUDED_GENERATED_StringifyEnums_h
#ifndef RT_WITHOUT_PRAGMA_ONCE
# pragma once
#endif

#include "VBox/com/VirtualBox.h"

const char *stringifySettingsVersion(SettingsVersion_T aValue) RT_NOEXCEPT;
const char *stringifyAccessMode(AccessMode_T aValue) RT_NOEXCEPT;
const char *stringifyMachineState(MachineState_T aValue) RT_NOEXCEPT;
const char *stringifySessionState(SessionState_T aValue) RT_NOEXCEPT;
const char *stringifyPlatformArchitecture(PlatformArchitecture_T aValue) RT_NOEXCEPT;
const char *stringifyCPUArchitecture(CPUArchitecture_T aValue) RT_NOEXCEPT;
const char *stringifyCPUPropertyTypeX86(CPUPropertyTypeX86_T aValue) RT_NOEXCEPT;
const char *stringifyHWVirtExPropertyType(HWVirtExPropertyType_T aValue) RT_NOEXCEPT;
const char *stringifyParavirtProvider(ParavirtProvider_T aValue) RT_NOEXCEPT;
const char *stringifyLockType(LockType_T aValue) RT_NOEXCEPT;
const char *stringifySessionType(SessionType_T aValue) RT_NOEXCEPT;
const char *stringifyDeviceType(DeviceType_T aValue) RT_NOEXCEPT;
const char *stringifyDeviceActivity(DeviceActivity_T aValue) RT_NOEXCEPT;
const char *stringifyClipboardMode(ClipboardMode_T aValue) RT_NOEXCEPT;
const char *stringifyDnDMode(DnDMode_T aValue) RT_NOEXCEPT;
const char *stringifyScope(Scope_T aValue) RT_NOEXCEPT;
const char *stringifyFirmwareBootMenuMode(FirmwareBootMenuMode_T aValue) RT_NOEXCEPT;
const char *stringifyAPICMode(APICMode_T aValue) RT_NOEXCEPT;
const char *stringifyProcessorFeature(ProcessorFeature_T aValue) RT_NOEXCEPT;
const char *stringifyFirmwareType(FirmwareType_T aValue) RT_NOEXCEPT;
const char *stringifyPointingHIDType(PointingHIDType_T aValue) RT_NOEXCEPT;
const char *stringifyKeyboardHIDType(KeyboardHIDType_T aValue) RT_NOEXCEPT;
const char *stringifyBitmapFormat(BitmapFormat_T aValue) RT_NOEXCEPT;
const char *stringifyPartitioningType(PartitioningType_T aValue) RT_NOEXCEPT;
const char *stringifyPartitionType(PartitionType_T aValue) RT_NOEXCEPT;
const char *stringifyDHCPOption(DHCPOption_T aValue) RT_NOEXCEPT;
const char *stringifyDHCPOptionEncoding(DHCPOptionEncoding_T aValue) RT_NOEXCEPT;
const char *stringifyDHCPConfigScope(DHCPConfigScope_T aValue) RT_NOEXCEPT;
const char *stringifyDHCPGroupConditionType(DHCPGroupConditionType_T aValue) RT_NOEXCEPT;
const char *stringifyVFSType(VFSType_T aValue) RT_NOEXCEPT;
const char *stringifyImportOptions(ImportOptions_T aValue) RT_NOEXCEPT;
const char *stringifyExportOptions(ExportOptions_T aValue) RT_NOEXCEPT;
const char *stringifyCertificateVersion(CertificateVersion_T aValue) RT_NOEXCEPT;
const char *stringifyVirtualSystemDescriptionType(VirtualSystemDescriptionType_T aValue) RT_NOEXCEPT;
const char *stringifyVirtualSystemDescriptionValueType(VirtualSystemDescriptionValueType_T aValue) RT_NOEXCEPT;
const char *stringifyTpmType(TpmType_T aValue) RT_NOEXCEPT;
const char *stringifyRecordingDestination(RecordingDestination_T aValue) RT_NOEXCEPT;
const char *stringifyRecordingFeature(RecordingFeature_T aValue) RT_NOEXCEPT;
const char *stringifyRecordingAudioCodec(RecordingAudioCodec_T aValue) RT_NOEXCEPT;
const char *stringifyRecordingCodecDeadline(RecordingCodecDeadline_T aValue) RT_NOEXCEPT;
const char *stringifyRecordingVideoCodec(RecordingVideoCodec_T aValue) RT_NOEXCEPT;
const char *stringifyRecordingVideoScalingMode(RecordingVideoScalingMode_T aValue) RT_NOEXCEPT;
const char *stringifyRecordingRateControlMode(RecordingRateControlMode_T aValue) RT_NOEXCEPT;
const char *stringifySignatureType(SignatureType_T aValue) RT_NOEXCEPT;
const char *stringifyUefiVariableAttributes(UefiVariableAttributes_T aValue) RT_NOEXCEPT;
const char *stringifyGraphicsControllerType(GraphicsControllerType_T aValue) RT_NOEXCEPT;
const char *stringifyGraphicsFeature(GraphicsFeature_T aValue) RT_NOEXCEPT;
const char *stringifyCleanupMode(CleanupMode_T aValue) RT_NOEXCEPT;
const char *stringifyCloneMode(CloneMode_T aValue) RT_NOEXCEPT;
const char *stringifyCloneOptions(CloneOptions_T aValue) RT_NOEXCEPT;
const char *stringifyAutostopType(AutostopType_T aValue) RT_NOEXCEPT;
const char *stringifyVMProcPriority(VMProcPriority_T aValue) RT_NOEXCEPT;
const char *stringifyIommuType(IommuType_T aValue) RT_NOEXCEPT;
const char *stringifyVMExecutionEngine(VMExecutionEngine_T aValue) RT_NOEXCEPT;
const char *stringifyHostNetworkInterfaceMediumType(HostNetworkInterfaceMediumType_T aValue) RT_NOEXCEPT;
const char *stringifyHostNetworkInterfaceStatus(HostNetworkInterfaceStatus_T aValue) RT_NOEXCEPT;
const char *stringifyHostNetworkInterfaceType(HostNetworkInterfaceType_T aValue) RT_NOEXCEPT;
const char *stringifyUpdateChannel(UpdateChannel_T aValue) RT_NOEXCEPT;
const char *stringifyUpdateSeverity(UpdateSeverity_T aValue) RT_NOEXCEPT;
const char *stringifyUpdateState(UpdateState_T aValue) RT_NOEXCEPT;
const char *stringifyProxyMode(ProxyMode_T aValue) RT_NOEXCEPT;
const char *stringifyAdditionsFacilityType(AdditionsFacilityType_T aValue) RT_NOEXCEPT;
const char *stringifyAdditionsFacilityClass(AdditionsFacilityClass_T aValue) RT_NOEXCEPT;
const char *stringifyAdditionsFacilityStatus(AdditionsFacilityStatus_T aValue) RT_NOEXCEPT;
const char *stringifyAdditionsRunLevelType(AdditionsRunLevelType_T aValue) RT_NOEXCEPT;
const char *stringifyAdditionsUpdateFlag(AdditionsUpdateFlag_T aValue) RT_NOEXCEPT;
const char *stringifyGuestShutdownFlag(GuestShutdownFlag_T aValue) RT_NOEXCEPT;
const char *stringifyGuestSessionStatus(GuestSessionStatus_T aValue) RT_NOEXCEPT;
const char *stringifyGuestSessionWaitForFlag(GuestSessionWaitForFlag_T aValue) RT_NOEXCEPT;
const char *stringifyGuestSessionWaitResult(GuestSessionWaitResult_T aValue) RT_NOEXCEPT;
const char *stringifyGuestUserState(GuestUserState_T aValue) RT_NOEXCEPT;
const char *stringifyFileSeekOrigin(FileSeekOrigin_T aValue) RT_NOEXCEPT;
const char *stringifyProcessInputFlag(ProcessInputFlag_T aValue) RT_NOEXCEPT;
const char *stringifyProcessOutputFlag(ProcessOutputFlag_T aValue) RT_NOEXCEPT;
const char *stringifyProcessWaitForFlag(ProcessWaitForFlag_T aValue) RT_NOEXCEPT;
const char *stringifyProcessWaitResult(ProcessWaitResult_T aValue) RT_NOEXCEPT;
const char *stringifyFileCopyFlag(FileCopyFlag_T aValue) RT_NOEXCEPT;
const char *stringifyFsObjMoveFlag(FsObjMoveFlag_T aValue) RT_NOEXCEPT;
const char *stringifyDirectoryCreateFlag(DirectoryCreateFlag_T aValue) RT_NOEXCEPT;
const char *stringifyDirectoryCopyFlag(DirectoryCopyFlag_T aValue) RT_NOEXCEPT;
const char *stringifyDirectoryRemoveRecFlag(DirectoryRemoveRecFlag_T aValue) RT_NOEXCEPT;
const char *stringifyFsObjRenameFlag(FsObjRenameFlag_T aValue) RT_NOEXCEPT;
const char *stringifyProcessCreateFlag(ProcessCreateFlag_T aValue) RT_NOEXCEPT;
const char *stringifyProcessPriority(ProcessPriority_T aValue) RT_NOEXCEPT;
const char *stringifySymlinkType(SymlinkType_T aValue) RT_NOEXCEPT;
const char *stringifySymlinkReadFlag(SymlinkReadFlag_T aValue) RT_NOEXCEPT;
const char *stringifyProcessStatus(ProcessStatus_T aValue) RT_NOEXCEPT;
const char *stringifyProcessInputStatus(ProcessInputStatus_T aValue) RT_NOEXCEPT;
const char *stringifyPathStyle(PathStyle_T aValue) RT_NOEXCEPT;
const char *stringifyDirectoryStatus(DirectoryStatus_T aValue) RT_NOEXCEPT;
const char *stringifyFileAccessMode(FileAccessMode_T aValue) RT_NOEXCEPT;
const char *stringifyFileOpenAction(FileOpenAction_T aValue) RT_NOEXCEPT;
const char *stringifyFileSharingMode(FileSharingMode_T aValue) RT_NOEXCEPT;
const char *stringifyFileOpenExFlag(FileOpenExFlag_T aValue) RT_NOEXCEPT;
const char *stringifyFileStatus(FileStatus_T aValue) RT_NOEXCEPT;
const char *stringifyFsObjType(FsObjType_T aValue) RT_NOEXCEPT;
const char *stringifyDnDAction(DnDAction_T aValue) RT_NOEXCEPT;
const char *stringifyDirectoryOpenFlag(DirectoryOpenFlag_T aValue) RT_NOEXCEPT;
const char *stringifyMediumState(MediumState_T aValue) RT_NOEXCEPT;
const char *stringifyMediumType(MediumType_T aValue) RT_NOEXCEPT;
const char *stringifyMediumVariant(MediumVariant_T aValue) RT_NOEXCEPT;
const char *stringifyDataType(DataType_T aValue) RT_NOEXCEPT;
const char *stringifyDataFlags(DataFlags_T aValue) RT_NOEXCEPT;
const char *stringifyMediumFormatCapabilities(MediumFormatCapabilities_T aValue) RT_NOEXCEPT;
const char *stringifyPartitionTableType(PartitionTableType_T aValue) RT_NOEXCEPT;
const char *stringifyKeyboardLED(KeyboardLED_T aValue) RT_NOEXCEPT;
const char *stringifyMouseButtonState(MouseButtonState_T aValue) RT_NOEXCEPT;
const char *stringifyTouchContactState(TouchContactState_T aValue) RT_NOEXCEPT;
const char *stringifyFramebufferCapabilities(FramebufferCapabilities_T aValue) RT_NOEXCEPT;
const char *stringifyGuestMonitorStatus(GuestMonitorStatus_T aValue) RT_NOEXCEPT;
const char *stringifyScreenLayoutMode(ScreenLayoutMode_T aValue) RT_NOEXCEPT;
const char *stringifyNetworkAttachmentType(NetworkAttachmentType_T aValue) RT_NOEXCEPT;
const char *stringifyNetworkAdapterType(NetworkAdapterType_T aValue) RT_NOEXCEPT;
const char *stringifyNetworkAdapterPromiscModePolicy(NetworkAdapterPromiscModePolicy_T aValue) RT_NOEXCEPT;
const char *stringifyPortMode(PortMode_T aValue) RT_NOEXCEPT;
const char *stringifyUartType(UartType_T aValue) RT_NOEXCEPT;
const char *stringifyUSBControllerType(USBControllerType_T aValue) RT_NOEXCEPT;
const char *stringifyUSBConnectionSpeed(USBConnectionSpeed_T aValue) RT_NOEXCEPT;
const char *stringifyUSBDeviceState(USBDeviceState_T aValue) RT_NOEXCEPT;
const char *stringifyUSBDeviceFilterAction(USBDeviceFilterAction_T aValue) RT_NOEXCEPT;
const char *stringifyAudioDriverType(AudioDriverType_T aValue) RT_NOEXCEPT;
const char *stringifyAudioControllerType(AudioControllerType_T aValue) RT_NOEXCEPT;
const char *stringifyAudioCodecType(AudioCodecType_T aValue) RT_NOEXCEPT;
const char *stringifyAudioDirection(AudioDirection_T aValue) RT_NOEXCEPT;
const char *stringifyAudioDeviceType(AudioDeviceType_T aValue) RT_NOEXCEPT;
const char *stringifyAudioDeviceState(AudioDeviceState_T aValue) RT_NOEXCEPT;
const char *stringifyAuthType(AuthType_T aValue) RT_NOEXCEPT;
const char *stringifyReason(Reason_T aValue) RT_NOEXCEPT;
const char *stringifyStorageBus(StorageBus_T aValue) RT_NOEXCEPT;
const char *stringifyStorageControllerType(StorageControllerType_T aValue) RT_NOEXCEPT;
const char *stringifyChipsetType(ChipsetType_T aValue) RT_NOEXCEPT;
const char *stringifyNATAliasMode(NATAliasMode_T aValue) RT_NOEXCEPT;
const char *stringifyNATProtocol(NATProtocol_T aValue) RT_NOEXCEPT;
const char *stringifyBandwidthGroupType(BandwidthGroupType_T aValue) RT_NOEXCEPT;
const char *stringifyGuestDebugProvider(GuestDebugProvider_T aValue) RT_NOEXCEPT;
const char *stringifyGuestDebugIoProvider(GuestDebugIoProvider_T aValue) RT_NOEXCEPT;
const char *stringifyVBoxEventType(VBoxEventType_T aValue) RT_NOEXCEPT;
const char *stringifyGuestMouseEventMode(GuestMouseEventMode_T aValue) RT_NOEXCEPT;
const char *stringifyGuestMonitorChangedEventType(GuestMonitorChangedEventType_T aValue) RT_NOEXCEPT;
const char *stringifyFormValueType(FormValueType_T aValue) RT_NOEXCEPT;
const char *stringifyCloudMachineState(CloudMachineState_T aValue) RT_NOEXCEPT;
const char *stringifyCloudImageState(CloudImageState_T aValue) RT_NOEXCEPT;
const char *stringifyMetricType(MetricType_T aValue) RT_NOEXCEPT;
const char *stringifySymlinkPolicy(SymlinkPolicy_T aValue) RT_NOEXCEPT;

#endif /* INCLUDED_GENERATED_StringifyEnums_h */
